#!/usr/bin/python
from xml.dom import minidom
import sys, urllib, spore
sys.stderr.write("Downloading...\n")
adventures = spore.specialSearch("TOP_RATED", assetType="ADVENTURE")
print "The top rated adventures are:"
for i, a in enumerate(adventures):
    print "%i. %s" % (i+1, a.name)
idx = int(raw_input("Which one do you want to play? (by number) "))-1
adventures[idx].getDataUrls()
doc = minidom.parse(urllib.urlopen(adventures[idx].xml))
adventure = doc.getElementsByTagName("cScenarioResource")[0]
a = adventure.getElementsByTagName("introText")
if len(a) == 1:
    print a[0].firstChild.data.strip()
for number, act in enumerate(adventure.getElementsByTagName("acts")[0].getElementsByTagName("cScenarioAct")):
    print
    print "Act %i:" % (number+1),
    a = act.getElementsByTagName("name")
    if len(a) == 1:
        print "%s" % a[0].firstChild.data.strip()
    print
    a = act.getElementsByTagName("description")
    if len(a) == 1:
        print a[0].firstChild.data.strip()
    goals = []
    for goal in act.getElementsByTagName("goals")[0].getElementsByTagName("cScenarioGoal"):
        goals += [{}]
        goals[-1]["type"] = int(goal.getElementsByTagName("type")[0].firstChild.data.strip())
        sys.stderr.write("found type %i\n" % goals[-1]["type"])
        goals[-1]["dialog"] = []
        for dialog in goal.getElementsByTagName("dialog")[0].getElementsByTagName("cScenarioDialog"):
            goals[-1]["dialog"] += [dialog.getElementsByTagName("text")[0].firstChild.data.strip()]
        goals[-1]["complete"] = False
    numComplete = 0
    while numComplete < len(goals):
        action = raw_input(": ")
        if action == "quit":
            a = adventure.getElementsByTagName("loseText")
            if len(a) == 1:
                print a[0].firstChild.data.strip()
            quit(0)
        elif action == "exit":
            a = adventure.getElementsByTagName("loseText")
            if len(a) == 1:
                print a[0].firstChild.data.strip()
            exit(0)
        elif action == "help":
            print "Recognized commands:"
            print "talk"
            print "get"
            print "go"
            print "attack"
            print "You can also type a number if you can't figure out which to do."
        elif action.startswith("talk"):
            for goal in goals:
                if (goal["type"] == 2) and (not goal["complete"]):
                    break
                goal = None
            if goal == None:
                print "You can't %s now." % action
                continue
            for dialog in goal["dialog"]:
                print dialog
                raw_input("...")
            numComplete += 1
            goal["complete"] = True
        elif action.startswith("get"):
            for goal in goals:
                if (goal["type"] == 8) and (not goal["complete"]):
                    break
                goal = None
            if goal == None:
                print "You can't %s now." % action
                continue
            numComplete += 1
            goal["complete"] = True
        elif action.startswith("go"):
            for goal in goals:
                if (goal["type"] == 1) and (not goal["complete"]):
                    break
                goal = None
            if goal == None:
                print "You can't %s now." % action
                continue
            numComplete += 1
            goal["complete"] = True
        elif action.startswith("attack"):
            for goal in goals:
                if (goal["type"] == 3) and (not goal["complete"]):
                    break
                goal = None
            if goal == None:
                print "You can't %s now." % action
                continue
            numComplete += 1
            goal["complete"] = True
        elif action.isdigit():
            action = int(action)
            for goal in goals:
                if (goal["type"] == action) and (not goal["complete"]):
                    break
                goal = None
            if goal == None:
                print "You can't do that now."
                continue
            numComplete += 1
            goal["complete"] = True
a = adventure.getElementsByTagName("winText")
if len(a) == 1:
    print a[0].firstChild.data.strip()
